
Actor/Lure
	var
		shiny
		smelly
		vibration
		description

		pullCount
		fightCount
		endurance = 30
		breakChance = 10

		caughtFish = 0

		airGravity = 256
		waterGravity = 350

		airDamping = 0.01
		waterDamping = 0.25

		pullAccel = 400
		pullDelay = 0.5
		pullTimer

		Actor/Fish/fish

		wasInWater = 0

		maxDepth = 128

		cost

	density = 0

	mass = 5

	icon = 'Lure.dmi'

	Hook
		bound_x = 5
		bound_y = 5
		bound_height = 8
		bound_width = 8

		icon_state = "hook"
		description = "A bare hook. Might catch some of the stupidest fishes I guess"
		shiny = 1
		smelly = 0
		vibration = 2

	Bait1
		bound_x = 5
		bound_y = 1
		bound_height = 14
		bound_width = 8

		icon_state = "bait 1"
		description = "Some small baitfish. It's putrid smell is good at bringing in fish"
		shiny = 0
		smelly = 5
		vibration = 1

		cost = 40

	Steel
		bound_x = 4
		bound_y = 5
		bound_height = 14
		bound_width = 10

		icon_state = "d hook"
		description = "A shimmering steel hook. It ought to catch some predator's attention"
		shiny = 4
		smelly = 0
		vibration = 2

		cost = 100

	Crankbait
		icon_state = "lure 1"
		description = "This fish-like lure imitates the erratic motion of swimming fish."
		shiny = 5
		smelly = 0
		vibration = 5

		cost = 250

	updateStep()

		if(!isInWater())
			velocity.y -= airGravity * deltaTime
			damping = airDamping
			wasInWater = 0

		else
			if(wasInWater == 0)
				player << sound('splash.ogg',0,0,0,50)

				makeSplash()


			velocity.y -= waterGravity * deltaTime
			damping = waterDamping

			wasInWater = 1

		var/depth = (44 - y) * world.icon_size - step_y
		if(depth > maxDepth && velocity.y < 0)
			velocity.y = 0

		.=..()

	proc
		makeSplash()
			var/obj/O = new()
			O.loc = src.loc
			O.step_x = src.step_x
			O.step_y = src.step_y + src.bound_height
			O.icon = 'WaterSplash.dmi'
			O.plane = EFFECTS_PLANE
			spawn(6)
				del O

		isInWater()
			return locate(/Water) in obounds(src)

		pullTowards(Actor/A)
			if(pullTimer > gameTime) return

			pullTimer = gameTime + pullDelay

			var/dx = (A.x - x) * world.icon_size + A.step_x - step_x
			var/dy = (A.y - y) * world.icon_size + A.step_y - step_y
			var/vector/V = new(dx, dy, 0)
			V = V.normalize()

			velocity = V.multiply(pullAccel)

			for(var/Water/W in obounds(src))
				W.velocity = W.velocity.add(velocity)

			if(fish) incrementPull()

		incrementPull()
			pullCount++

			if(fightCount > endurance || pullCount > endurance)
				if(prob(breakChance))
					snapLine()

		incrementFight()
			fightCount++

			if(fightCount > endurance || pullCount > endurance)
				if(prob(breakChance))
					snapLine()

		snapLine()
			fish = null
			player.lineSnapText()
			player.controlState = 5
			player.stateTimer = gameTime + 1
			player.guy.icon_state = "pickup"
			del src

Line
	parent_type = /obj
	var
		endurance = 30
		maxDepth = 160
		cost

	Twine
		name = "Crude twine"
		endurance = 30
		maxDepth = 200

	Silk
		name = "Silk Twine"
		endurance = 40
		maxDepth = 350
		cost = 50

	Mono
		name = "Monofilament Line"
		endurance = 50
		maxDepth = 500
		cost = 100

	Braid
		name = "Nylon-Braid Line"
		endurance = 75
		maxDepth = 700
		cost = 200

	PVC
		name = "PVC Heavy Line"
		endurance = 150
		maxDepth = 800
		cost = 300


Rod
	parent_type = /obj
	var
		pullStrength = 400
		pullDelay = 0.5
		cost

	Basic
		name = "Basic rod"
		pullStrength = 600
		pullDelay = 0.75

	Bamboo
		name = "Bamboo rod"
		pullStrength = 550
		pullDelay = 0.5
		cost = 60

	Graphite
		name = "Graphite rod"
		pullStrength = 750
		pullDelay = 0.5
		cost = 120

	Carbon
		name = "Carbon-Fiber rod"
		pullStrength = 525
		pullDelay = 0.25
		cost = 300