
var
	activeActors[0]
	activeWater[0]

	gameTime = 0
	deltaTime

	gamePaused = 0

	killWorld = 0


	waterUpdateIndex = 1
	waterTriangleIndex = 1
	waterUpdateEnd = 0
	waterTriangleEnd = 0

	client/player


world
	fps = 30		// 25 frames per second
	icon_size = 16	// 32x32 icon size by default
	view = "21x25"

	hub = "D4RK354B3R.BarrelLake"
	hub_password = "AuI6C7m946cu9IO6"
	version = 4

	name = "MAKGAM2017: Fishin at Barrel Lake"

	New()
		.=..()
		initialization()
		mainLoop()

	Del()
		killWorld = 1
		.=..()

proc
	initialization()
		for(var/Water/W)
			W.init()
			W.updateTriangles()
			sleep(0)

		//activeWater.Cut()

		createPlaneMasters()

	mainLoop()
		while(1)
			deltaTime = world.tick_lag/10

			if(killWorld) return

			if(!gamePaused)
				gameTime += deltaTime

				if(player)
					player.processControls()

					if(player.camera)
						player.camera.updateStep()

				for(var/atom/A in activeActors)
					if(A.updateTimer > gameTime) continue
					A.updateStep()


				if(player && activeWater.len > 0)
					var/renderRange = 11
					var/triangleTickThresh = 60
					var/waterUpdateThresh = 30

					waterUpdateEnd = (waterUpdateIndex + activeWater.len - 1) % (activeWater.len)
					waterTriangleEnd = (waterTriangleIndex + activeWater.len - 1) % (activeWater.len)


					if(player.camera)
						for(var/Water/W in range(renderRange, player.camera))
							if(world.tick_usage > waterUpdateThresh/2) break
							if(W.updateTimer < gameTime)
								W.updateStep()


					while(waterUpdateIndex != waterUpdateEnd)
						if(world.tick_usage > waterUpdateThresh) break

						var/Water/A = activeWater[waterUpdateIndex]

						waterUpdateIndex++
						if(waterUpdateIndex > activeWater.len) waterUpdateIndex = 1

						if(A.updateTimer > gameTime) continue

						A.updateStep()


					while(waterTriangleIndex != waterTriangleEnd)
						if(world.tick_usage > triangleTickThresh) break


						var/Water/A = activeWater[waterTriangleIndex]

						waterTriangleIndex++
						if(waterTriangleIndex > activeWater.len) waterTriangleIndex = 1

						if(get_dist(A, player.eye) > renderRange) continue

						A.updateTriangles()


			if(killWorld) return

			sleep(world.tick_lag)
			sleep(0)

atom
	var
		updateTimer = 0
	proc
		updateStep()

	movable
		var
			vector/velocity = new(0,0,0)

			tmp
				dx=0
				dy=0

		proc
			applyVelocity()
				if(!velocity) return
				if(velocity.x == 0 && velocity.y == 0) return

				dx += velocity.x * deltaTime
				dy += velocity.y * deltaTime

				var/vdx = round(dx,1), vdy = round(dy,1)
				dx -= vdx
				dy -= vdy

				if(vdx > 0)
					step(src, EAST, vdx)

				if(vdx < 0)
					step(src, WEST, -vdx)

				if(vdy > 0)
					step(src, NORTH, vdy)

				if(vdy < 0)
					step(src, SOUTH, -vdy)

/*
turf
	icon = 'Test.dmi'
*/

client
	New()
		.=..()
		if(!player) player = src
		else del src

		for(var/obj/O in PLANE_MASTERS)
			screen += O

		mob.loc = locate(11,22,1)

		showTitleScreen()

	proc
		showTitleScreen()
			gamePaused = 1

			var/obj/shopButtonHUD/O = new()
			O.screen_loc = "1,1"
			O.icon = 'title.png'
			O.procName = "closeTitleScreen"
			HUD["title"] = O
			screen += O


		closeTitleScreen()
			var/obj/O = HUD["title"]
			animate(O, alpha = 0, time = 10)
			spawn(10)
				del O

			showIntroDialog()

		showIntroDialog()
			var/obj/shopButtonHUD/O = new()
			O.screen_loc = "WEST, SOUTH to EAST, NORTH"
			O.icon = 'Black.dmi'
			O.procName = "closeIntroDialog"
			O.alpha = 0
			HUD["fade"] = O
			screen += O

			animate(O, alpha = 255, time = 10)

			sleep(5)

			var/obj/DialogTextHUD/H = new()
			screen += H
			H.showText("After that boating accident, I'm in ruins! It's embarrassing as a competitive fisherman to lose all of his expensive equipment in a mishap.\n\
				Especially with all of this crippling debt hanging over my shoulders!\n\n\
				I truly shouldn't have purchased that life-supply of caviar... And then left it on the boat!\n\n\
				All I have left to my name is a crummy stick and a piece of twine. Hardly a fisherman's equipment! \n\n\
				However, there's supposedly a legendary Abyssal Deviltooth hanging around the bottom of ol' Barrel Lake by my hometown.\n\
				If I can catch that Deviltooth within a week, then maybe I shouldn't give this up afterall.\n\n\
				Imagine the fortune and glory from such a catch!\n\n\
				Maybe, just maybe, starting from square one for this is worth the effort...")


		closeIntroDialog()
			var/obj/O = HUD["fade"]
			animate(O, alpha = 0, time = 10)

			for(var/obj/DialogTextHUD/H in screen) del H
			sleep(5)

			gamePaused = 0
			sleep(5)
			del O