vector
	var
		x
		y
		z

	New(nx, ny, nz)
		x = nx
		y = ny
		z = nz


	proc
		add(vector/b)
			return new/vector(x + b.x, y + b.y, z + b.z)

		subtract(vector/b)
			return new/vector(x - b.x, y - b.y, z - b.z)

		multiply(scalar)
			return new/vector(x * scalar, y * scalar, z * scalar)

		normalize()
			var/length = vectorLength()
			if(length == 1) return src
			return multiply(1 / length)

		vectorLength()
			return sqrt(x*x + y*y + z*z)

		vectorLengthSquared()
			return x*x + y*y + z*z

		dot(vector/b)
			return x * b.x + y * b.y + z * b.z

		clone()
			return multiply(1)

		cross(vector/b)
			var
				nx =  y * b.z - b.y * z
				ny = -x * b.z + b.x * z
				nz =  x * b.y - b.x * y

			return new/vector(nx, ny, nz)

		projectOnto(vector/b)
			var/ab = src.dot(b)
			var/bb = b.dot(b)
			return b.multiply(ab/bb)